package mutagen

import (
	"math/rand"
	"time"

	neuralnetwork "../../neuralnetwork"
)

type DummyMutagen struct {
	chance uint32
}

func NewDummyMutagen(chance uint32) (rm *DummyMutagen) {
	rm = &DummyMutagen{
		chance: chance,
	}
	return
}

func (rm *DummyMutagen) Mutate(network *neuralnetwork.NeuralNetwork) {
	rand.Seed(time.Now().UnixNano())
	for l := 1; l < network.LayerCount; l++ {
		randomized := rand.Float64()
		if randomized < (float64(rm.chance) / 100.0) {
			r, c := network.Weights[l].Dims()
			for o := 0; o < 10; o++ {
				mutationRow := int(rand.Uint32()) % r
				mutationColumn := int(rand.Uint32()) % c
				weight := rand.Float64()
				network.Weights[l].Set(mutationRow, mutationColumn, weight)
			}
		}
	}
}
